wout=50;
dout =50;
hout=10;
fd=2;
fd2=1;
mw=4.4;
mh=6;

module field(p,m){
  difference() {
    cube([wout,dout,hout],center=true);
    translate([0,0,hout/2-fd])
        cylinder(d1=wout-2*fd,d2=dout-fd,h=fd,$fn=4);
    translate([0,0,hout/2-fd-fd2])
        cylinder(d1=wout-2*fd2,d2=dout-fd2,h=fd2,$fn=4);
    rotate([0,0,45])
      translate([0,0,hout/2-fd])
        cylinder(d1=2^0.5*(wout-2*fd),d2=2^0.5*(dout-fd),h=fd,$fn=4);
    #translate([0,0,-(hout/2-fd)])
        cylinder(d2=wout-2*fd2,d1=dout-fd2,h=fd2,$fn=4);
    rotate([0,0,45])
      translate([0,0,-hout/2])
        cylinder(d2=2^0.5*(wout-2*fd),d1=2^0.5*(dout-fd),h=fd,$fn=4);
    translate([0,0,-mh/2])
        cylinder(d=mw,h=mh,$fn=32);
  }
  
  // Magnet Trennschicht
  translate([0,0,-0.4/2])
        cylinder(d=mw,h=0.4,$fn=32);
  
      union(){
        translate([wout/2-wout/6,dout/2-dout/6,hout/2-2])  
            sign(p);  
        translate([wout/2-wout/6,-dout/2+dout/6,hout/2-2])  
          rotate([0,0,90])
            sign(p);  
        translate([-wout/2+wout/6,dout/2-dout/6,hout/2-2])  
          rotate([0,0,90])
            sign(p);  
        translate([-wout/2+wout/6,-dout/2+dout/6,hout/2-2])  
            sign(p);  
      }
      union(){
        translate([wout/2-wout/6,dout/2-dout/6,-hout/2+2])  
            sign(m);  
        translate([wout/2-wout/6,-dout/2+dout/6,-hout/2+2])  
          rotate([0,0,90])
            sign(m);  
        translate([-wout/2+wout/6,dout/2-dout/6,-hout/2+2])  
          rotate([0,0,90])
            sign(m);  
        translate([-wout/2+wout/6,-dout/2+dout/6,-hout/2+2])  
            sign(m);  
      }

}


module sign(n) {
    if (n==0) { // Kreuz
    rotate([90,0,0])    
     translate([0,0,-5])   
      union(){  
        cylinder(h=10,d=2,$fn=6);
        translate([-5,0,5])
        rotate([0,90,0])
            cylinder(h=10,d=2,$fn=6);
      }
    }
    if (n==1) { // Diagonale
    rotate([90,0,0])    
     rotate([0,-45,0])
      translate([-5,0,-5])   
      union(){  
        translate([2,0,0])
            cylinder(h=9,d=2,$fn=6);
        translate([5,0,0])
            cylinder(h=9,d=2,$fn=6);
        translate([8,0,0])
            cylinder(h=9,d=2,$fn=6);
      }
    }
    if (n==2) { // Kreis
        rotate_extrude(convexity = 10)
        translate([4, 0, 0])
        circle(r = 1);
    }
    if (n==3) { // leer
        }
}

//fx=4;
//fy=4;
//
//for(d=[0:1:fy-1]) {
//  for(w=[0:1:fx-1]) {
//    translate([w*wout,d*dout,0])
//        field(2*d+w,2*d+w);
//  }
//}  

module fxy(x,y,p,m) {
    translate([x*wout,y*dout,0])
        field(p,m);    
}

module board1() {
    fxy(0,0,0,0);
    fxy(1,0,3,3);
    fxy(2,0,2,2);
    fxy(3,0,1,1);

    fxy(0,1,1,1);
    fxy(1,1,1,1);
    fxy(2,1,2,2);
    fxy(3,1,0,0);

    fxy(0,2,3,3);
    fxy(1,2,0,0);
    fxy(2,2,3,3);
    fxy(3,2,2,2);

    fxy(0,3,2,2);
    fxy(1,3,1,1);
    fxy(2,3,0,0);
    fxy(3,3,3,3);
}

board1();


